<template>
  <b-container>
    <h1>New Filter Submission</h1>
    <p>Thank you for your interest in submitting a filter to ANTARES.</p>
    <hr>
    <b-form @submit.prevent="submitFilter">
      <b-form-group label="Filter Name">
        <b-form-input
          ref="filterNameInput"
          v-model="filter.name"
          :disabled="submitting"
          :state="$v.filter.name.$dirty ? ($v.filter.name.$invalid ? false : true) : null"
          placeholder="Enter the name of your filter"
          @input="$v.filter.name.$touch"
        />
        <b-form-text v-if="!$v.filter.name.$dirty || !$v.filter.name.$invalid">
          Filter names must begin with a lowercase or uppercase letter and may contain up to 64
          characters. They may contain letters, numbers, spaces, underscores, hyphens and periods.
        </b-form-text>
        <b-form-invalid-feedback v-else-if="!$v.filter.name.required">
          Field is required.
        </b-form-invalid-feedback>
        <b-form-invalid-feedback v-else-if="!$v.filter.name.maxLength">
          Field may not have more than 64 characters.
        </b-form-invalid-feedback>
        <b-form-invalid-feedback v-else-if="!$v.filter.name.validCharacters">
          Field contains invalid characters.
        </b-form-invalid-feedback>
      </b-form-group>
      <b-form-group label="Filter Description">
        <b-form-textarea
          v-model="filter.description"
          :disabled="submitting"
          :state="
            $v.filter.description.$dirty ? ($v.filter.description.$invalid ? false : true) : null
          "
          placeholder="Enter a description for your filter"
          rows="2"
          @input="$v.filter.description.$touch"
        />
        <b-form-text v-if="!$v.filter.description.$dirty || !$v.filter.description.$invalid">
          Enter up to 2048 characters describing this filter.
        </b-form-text>
        <b-form-invalid-feedback v-else-if="!$v.filter.name.required">
          Field is required.
        </b-form-invalid-feedback>
        <b-form-invalid-feedback v-else-if="!$v.filter.name.maxLength">
          Field may not have more than 64 characters.
        </b-form-invalid-feedback>
      </b-form-group>
      <b-alert
        v-model="showErrorMessage"
        class="mb-3"
        dismissible
        variant="danger"
      >
        {{
          errorMessage
        }}
      </b-alert>
      <div style="overflow: hidden;">
        <div class="float-right">
          <b-button
            :disabled="submitting"
            :to="{ name: 'filterList' }"
            class="mr-1"
            variant="danger"
          >
            <font-awesome-icon icon="times" />
            Cancel
          </b-button>
          <b-button
            :disabled="$v.$invalid || submitting"
            type="submit"
            variant="success"
          >
            <font-awesome-icon
              v-if="submitting"
              icon="spinner"
              pulse
            />
            <font-awesome-icon
              v-else
              icon="arrow-right"
            />
            Continue
          </b-button>
        </div>
      </div>
    </b-form>
  </b-container>
</template>

<script lang="ts">
/* eslint-disable no-alert, no-useless-escape, vars-on-top, no-var, block-scoped-var */
import Vue from 'vue';
import { helpers, maxLength, required } from 'vuelidate/lib/validators';
import { Filter } from '@/common/types';
import { FilterService } from '@/api';

export default Vue.extend({
  beforeRouteLeave(to, from, next) {
    if (this.$v.$anyDirty && !this.submitted) {
      const confirmed = window.confirm('You have unsaved changes, do you really want to leave?');
      if (confirmed) {
        next();
      }
      return;
    }
    next();
  },

  data() {
    return {
      filter: {} as Filter,
      errorMessage: '',
      showErrorMessage: false,
      submitted: false,
      submitting: false,
    };
  },

  validations: {
    filter: {
      description: {
        maxLength: maxLength(2048),
        required,
      },
      name: {
        validCharacters: helpers.regex('validCharacters', /^[a-zA-Z][a-zA-Z0-9_\-\. ]*$/),
        maxLength: maxLength(64),
        required,
      },
    },
  },

  methods: {
    async submitFilter() {
      this.submitting = true;
      try {
        var {
          data: { id: filterId },
        } = await FilterService.create(this.filter);
      } catch (errors) {
        if (errors[0].status === 409) {
          this.errorMessage = 'This name is already in use, please choose another.';
        } else {
          this.errorMessage = 'An error occurred while submitting your filter.';
        }
        this.showErrorMessage = true;
        return;
      } finally {
        this.submitting = false;
      }
      this.submitted = true;
      this.$router.push({
        name: 'filterDetail',
        params: { filterId },
      });
    },
  },
});
</script>

<style scoped>
.alert {
  margin-bottom: 0;
  border-radius: 0;
}
</style>
